' NES BUS
DIM INTEGER cpuRAM(2047)
DIM INTEGER systemClockCounter

DIM INTEGER DMApage, DMAaddr, DMAdata
DIM INTEGER boolDMAdummy = 1
DIM INTEGER boolDMAtransfer = 0
DIM INTEGER BOOLFRAMECOMPLETE = 0
DIM INTEGER controller(1)
DIM INTEGER controllerstate(1)

DIM INTEGER DISADDR

SUB BUSW (ADDR, CARTDATA)
  IF CARTCPUWRITE(ADDR, CARTDATA) THEN
  ELSE IF (addr >= &H0000 AND addr <= &H1FFF) THEN
    cpuRAM(addr AND &H07FF) = CARTDATA
  ELSE IF (addr >= &H2000 AND addr <= &H3FFF) THEN
    PPUCPUWRITE((addr AND &H0007), CARTDATA)
  ELSE IF (addr = &H4014) THEN
    DMApage = CARTDATA
    DMAaddr = &H00
    boolDMAtransfer = 1
  ELSE IF (addr >= &H4016 AND addr <= &H4017) THEN
    controllerState(addr AND &H0001) = controller(addr AND &H0001)
  END IF
DISADDR = ADDR
END SUB

FUNCTION BUSR(ADDR)
  IF CARTCPUREAD(ADDR, 0) THEN
  ELSE IF (ADDR >= &H0000 AND ADDR <= &H1FFF) THEN
    CARTDATA = CPURAM(ADDR AND &H07FF)
  ELSE IF (ADDR >= &H2000 AND ADDR <= &H3FFF) THEN
    CARTDATA = PPUCPUREAD(ADDR AND &H0007)
  ELSE IF (ADDR >= &H4016 AND ADDR <= &H4017) THEN
    CARTDATA = (CONTROLLERSTATE(ADDR AND &H0001) AND &H80) > 0
    CONTROLLERSTATE(ADDR AND &H0001) = (CONTROLLERSTATE(ADDR AND &H0001) << 1) AND &HFF
  END IF
  DISADDR = ADDR
  BUSR = CARTDATA
END FUNCTION

SUB BUSreset()
  CPUreset()
  PPUreset()
  systemClockCounter = 0
  DMApage = 0
  DMAaddr = 0
  DMAdata = 0
  boolDMAdummy = 1
  boolDMAtransfer = 0
IF DEBUG THEN : PRINT "RESET COMPLETE" : END IF
END SUB

SUB BUSclock()
  PPUclock()
    if systemClockCounter MOD 3 = 0 THEN
      if boolDMAtransfer = 1 THEN
        if boolDMAdummy = 1 then
          if systemClockCounter MOD 2 = 1 THEN
            boolDMAdummy = 0
          END IF
        else 
          if systemClockCounter MOD 2 = 0 then
            DMAdata = BUSR((DMApage << 8) OR (DMAaddr)) AND &HFF
          ELSE
            PPUsetOAMdata((DMAaddr AND &HFF), (DMAdata AND &HFF)) 
            DMAaddr = (DMAaddr + 1) AND &HFF
            if (DMAaddr = 0) THEN
              boolDMAtransfer = 0
              boolDMAdummy = 1
            end if
          end if
        end if
      ELSE
        CPUclock() 
        systemClockCounter = 0
      END if
    END if
    IF BNMI = 1 THEN
      BNMI = 0
      NMICPU()
    ENDIF
'SOUND AND MAPPER RELATED. DISABLED FOR NOW...
'  IF bIRQActive = 1 then
'    bIRQActive = 0
'    IRQCPU()
'  ENDIF
  systemClockCounter = systemClockCounter + 1
END sub
